pcl::cuda::PointCloudSOA< Storage > Class Template Reference

PointCloudSOA represents a SOA (Struct of Arrays) PointCloud implementation for CUDA processing. More...

`#include </build/pcl-qv3n_B/pcl-1.8.1+dfsg1/cuda/common/include/pcl/cuda/point_cloud.h>`

## Public Types

typedef boost::shared_ptr< PointCloudSOA< Storage > > | Ptr
typedef boost::shared_ptr< const PointCloudSOA< Storage > > | ConstPtr
typedef thrust::tuple< float, float, float > | tuple_type
typedef Storage< float >::type::iterator | float_iterator
typedef thrust::tuple< float_iterator, float_iterator, float_iterator > | iterator_tuple
typedef thrust::zip_iterator< iterator_tuple > | zip_iterator

## Public Member Functions

| PointCloudSOA ()
PointCloudSOA & | operator= (const PointCloudSOA &rhs)
template<typename OtherStorage >
PointCloudSOA & | operator<< (const OtherStorage &rhs)
void | resize (size_t newsize)
| Resize the internal point data vectors. More...
std::size_t | size () const
| Return the size of the internal vectors. More...
bool | sane () const
| Check if the internal pooint data vectors are valid. More...
zip_iterator | zip_begin ()
zip_iterator | zip_end ()

## Public Attributes

Storage< float >::type | points_x
| The point data. More...
Storage< float >::type | points_y
Storage< float >::type | points_z
Storage< int >::type | rgb
unsigned int | width
| The point cloud width (if organized as an image-structure). More...
unsigned int | height
| The point cloud height (if organized as an image-structure). More...
bool | is_dense
| True if no points are invalid (e.g., have NaN or Inf values). More...

## Detailed Description

### template<template< typename > class Storage>
class pcl::cuda::PointCloudSOA< Storage >

PointCloudSOA represents a SOA (Struct of Arrays) PointCloud implementation for CUDA processing.

Definition at line 209 of file point_cloud.h.

## Member Typedef Documentation

## ConstPtr

template<template< typename > class Storage>

typedef boost::shared_ptr<const PointCloudSOA<Storage> > pcl::cuda::PointCloudSOA< Storage >::ConstPtr

Definition at line 283 of file point_cloud.h.

## float_iterator

template<template< typename > class Storage>

typedef Storage<float>::type::iterator pcl::cuda::PointCloudSOA< Storage >::float_iterator

Definition at line 288 of file point_cloud.h.

## iterator_tuple

template<template< typename > class Storage>

typedef thrust::tuple<float_iterator, float_iterator, float_iterator> pcl::cuda::PointCloudSOA< Storage >::iterator_tuple

Definition at line 289 of file point_cloud.h.

## Ptr

template<template< typename > class Storage>

typedef boost::shared_ptr<PointCloudSOA<Storage> > pcl::cuda::PointCloudSOA< Storage >::Ptr

Definition at line 282 of file point_cloud.h.

## tuple_type

template<template< typename > class Storage>

typedef thrust::tuple<float, float, float> pcl::cuda::PointCloudSOA< Storage >::tuple_type

Definition at line 287 of file point_cloud.h.

## zip_iterator

template<template< typename > class Storage>

typedef thrust::zip_iterator<iterator_tuple> pcl::cuda::PointCloudSOA< Storage >::zip_iterator

Definition at line 290 of file point_cloud.h.

## Constructor & Destructor Documentation

## PointCloudSOA()

template<template< typename > class Storage>

pcl::cuda::PointCloudSOA< Storage >::PointCloudSOA | ( |  | ) |

inline

Definition at line 212 of file point_cloud.h.

## Member Function Documentation

## operator<<()

template<template< typename > class Storage>
template<typename OtherStorage >

PointCloudSOA& pcl::cuda::PointCloudSOA< Storage >::operator<< | ( | const OtherStorage & | rhs | ) |

inline

Definition at line 229 of file point_cloud.h.

## operator=()

template<template< typename > class Storage>

PointCloudSOA& pcl::cuda::PointCloudSOA< Storage >::operator= | ( | const PointCloudSOA< Storage > & | rhs | ) |

inline

Definition at line 216 of file point_cloud.h.

References pcl::cuda::PointCloudSOA< Storage >::height, pcl::cuda::PointCloudSOA< Storage >::is_dense, pcl::cuda::PointCloudSOA< Storage >::points_x, pcl::cuda::PointCloudSOA< Storage >::points_y, pcl::cuda::PointCloudSOA< Storage >::points_z, and pcl::cuda::PointCloudSOA< Storage >::width.

## resize()

template<template< typename > class Storage>

void pcl::cuda::PointCloudSOA< Storage >::resize | ( | size_t | newsize | ) |

inline

Resize the internal point data vectors.

Parameters

  newsize | the new size

Definition at line 244 of file point_cloud.h.

## sane()

template<template< typename > class Storage>

bool pcl::cuda::PointCloudSOA< Storage >::sane | ( |  | ) | const

inline

Check if the internal pooint data vectors are valid.

Definition at line 262 of file point_cloud.h.

## size()

template<template< typename > class Storage>

std::size_t pcl::cuda::PointCloudSOA< Storage >::size | ( |  | ) | const

inline

Return the size of the internal vectors.

Definition at line 254 of file point_cloud.h.

## zip_begin()

template<template< typename > class Storage>

zip_iterator pcl::cuda::PointCloudSOA< Storage >::zip_begin | ( |  | ) |

inline

Definition at line 293 of file point_cloud.h.

## zip_end()

template<template< typename > class Storage>

zip_iterator pcl::cuda::PointCloudSOA< Storage >::zip_end | ( |  | ) |

inline

Definition at line 301 of file point_cloud.h.

## Member Data Documentation

## height

template<template< typename > class Storage>

unsigned int pcl::cuda::PointCloudSOA< Storage >::height

The point cloud height (if organized as an image-structure).

Definition at line 277 of file point_cloud.h.

Referenced by pcl::cuda::PointCloudSOA< Storage >::operator=().

## is_dense

template<template< typename > class Storage>

bool pcl::cuda::PointCloudSOA< Storage >::is_dense

True if no points are invalid (e.g., have NaN or Inf values).

Definition at line 280 of file point_cloud.h.

Referenced by pcl::cuda::PointCloudSOA< Storage >::operator=().

## points_x

template<template< typename > class Storage>

Storage<float>::type pcl::cuda::PointCloudSOA< Storage >::points_x

The point data.

Definition at line 269 of file point_cloud.h.

Referenced by pcl::cuda::PointCloudSOA< Storage >::operator=().

## points_y

template<template< typename > class Storage>

Storage<float>::type pcl::cuda::PointCloudSOA< Storage >::points_y

Definition at line 270 of file point_cloud.h.

Referenced by pcl::cuda::PointCloudSOA< Storage >::operator=().

## points_z

template<template< typename > class Storage>

Storage<float>::type pcl::cuda::PointCloudSOA< Storage >::points_z

Definition at line 271 of file point_cloud.h.

Referenced by pcl::cuda::PointCloudSOA< Storage >::operator=().

## rgb

template<template< typename > class Storage>

Storage<int>::type pcl::cuda::PointCloudSOA< Storage >::rgb

Definition at line 272 of file point_cloud.h.

## width

template<template< typename > class Storage>

unsigned int pcl::cuda::PointCloudSOA< Storage >::width

The point cloud width (if organized as an image-structure).

Definition at line 275 of file point_cloud.h.

Referenced by pcl::cuda::PointCloudSOA< Storage >::operator=().

The documentation for this class was generated from the following file:

- /build/pcl-qv3n_B/pcl-1.8.1+dfsg1/cuda/common/include/pcl/cuda/point_cloud.h